// HookKeyHook.cpp: CHookKeyHook NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include <tlhelp32.h>
#include "HookKeyHook.h"

/* Defines */
#define		ONHOOKKEY_EVENT_NAME		_T("OnHookKey")
#define		OFFHOOKKEY_EVENT_NAME		_T("OffHookKey")
#define		ONHOOKKEY_NEW_EVENT_NAME	_T("0nHookKey")
#define		OFFHOOKKEY_NEW_EVENT_NAME	_T("0ffHookKey")
#define		SLIDEOPEN_EVENT_NAME		_T("SlideOpen")
#define		SLIDECLOSE_EVENT_NAME		_T("SlideClose")
#define		SLIDEOPEN_NEW_EVENT_NAME	_T("$lideOpen")
#define		SLIDECLOSE_NEW_EVENT_NAME	_T("$lideClose")

#define		KEYBOARD_DRIVER_DLLNAME		_T("d2keybd.dll")
#define		GWES_WND_CLASS_NAME			_T("TOUCHSTUBWND_CLASS")

//
static
BOOL
GetModuleLoadedAddr(
	DWORD	dwProcessID,	// IN
	LPTSTR	szModuleName,	// IN
	LPBYTE*	ppBaseAddr,		// OUT
	LPDWORD	pdwBaseSize		// OUT
)
{
	BOOL	bRet;
	HANDLE	hModuleSnap  = INVALID_HANDLE_VALUE;

	bRet = FALSE;

	hModuleSnap = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, dwProcessID);
	if (hModuleSnap != INVALID_HANDLE_VALUE) {

		BOOL			bGetEntrySucc;
		MODULEENTRY32	moduleEntry;

		memset(&moduleEntry, 0, sizeof(moduleEntry));
		moduleEntry.dwSize = sizeof(moduleEntry);

		bGetEntrySucc = Module32First(hModuleSnap, &moduleEntry);

		while (bGetEntrySucc) {

			if (_tcsicmp(szModuleName, moduleEntry.szModule) == 0) {
				*ppBaseAddr = moduleEntry.modBaseAddr;
				*pdwBaseSize = moduleEntry.modBaseSize;
				bRet = TRUE;
				break;
			}

			bGetEntrySucc = Module32Next(hModuleSnap, &moduleEntry);
		}

		CloseHandle(hModuleSnap);
		hModuleSnap = INVALID_HANDLE_VALUE;
	}

	return bRet;
}

static
BOOL
GetPatchProcessInfo(
	HKH_PATCHPROCESSINFO*	pProcessInfo
)
{
	BOOL	bRet;
	HWND	hWnd;
	DWORD	dwProcessId;
	LPBYTE	pBaseAddr = NULL;
	DWORD	dwBaseSize = 0;


	bRet = FALSE;

	if (pProcessInfo == NULL) {
		return FALSE;
	}

	hWnd = FindWindow(GWES_WND_CLASS_NAME, NULL);
	if (hWnd != NULL) {

		GetWindowThreadProcessId(hWnd, &dwProcessId);
		if (GetModuleLoadedAddr(dwProcessId, KEYBOARD_DRIVER_DLLNAME, &pBaseAddr, &dwBaseSize)) {

			memset(pProcessInfo, 0, sizeof(HKH_PATCHPROCESSINFO));

			pProcessInfo->dwProcessId = dwProcessId;
			pProcessInfo->pBaseAddr = pBaseAddr;
			pProcessInfo->dwBaseSize = dwBaseSize;

			bRet = TRUE;
		}
	}

	return bRet;
}

static
BOOL
doPatch(
	DWORD				dwFlag,
	HKH_PATCHPROCESSINFO*	pPatchProcessInfo
)
{
	BOOL	bRet;
	HANDLE	hProcess				= NULL;
	BYTE	bTmpBuf[32];
	DWORD	dwOnHookPatchOffset		= 0;
	DWORD	dwOffHookPatchOffset	= 0;
	DWORD	dwSlideOpenPatchOffset	= 0;
	DWORD	dwSlideClosePatchOffset = 0;
	BOOL	bCanPatch				= FALSE;

	// ̂ւ̃WbN͂߂Kɂ

	bRet = FALSE;	// default return value

	if (dwFlag == 0 || pPatchProcessInfo == NULL) {
		return FALSE;
	}

	hProcess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, pPatchProcessInfo->dwProcessId);
	if (hProcess != NULL) {
		DWORD	dwOffset = 0;
		BOOL	bReadSucc;
		DWORD	dwRead;
		DWORD	dwWritten;

		bCanPatch = TRUE;

		if (bCanPatch && (dwFlag & HKH_HOOK_ONHOOK)) {
			// OnHooǩ
			bCanPatch = FALSE;

			for (dwOffset = 0; dwOffset < pPatchProcessInfo->dwBaseSize - sizeof(ONHOOKKEY_EVENT_NAME); dwOffset++) {
				bReadSucc = ReadProcessMemory(hProcess, pPatchProcessInfo->pBaseAddr+dwOffset, bTmpBuf, sizeof(ONHOOKKEY_EVENT_NAME), &dwRead);
				if (bReadSucc) {
					if (memcmp(bTmpBuf, ONHOOKKEY_EVENT_NAME, sizeof(ONHOOKKEY_EVENT_NAME)) == 0) {
						dwOnHookPatchOffset = dwOffset;
						bCanPatch = TRUE;
						break;
					}
				}
			}
		}
		//

		if (bCanPatch && (dwFlag & HKH_HOOK_OFFHOOK)) {
			// OffHooǩ
			bCanPatch = FALSE;

			for (dwOffset = 0; dwOffset < pPatchProcessInfo->dwBaseSize - sizeof(OFFHOOKKEY_EVENT_NAME); dwOffset++) {
				bReadSucc = ReadProcessMemory(hProcess, pPatchProcessInfo->pBaseAddr+dwOffset, bTmpBuf, sizeof(OFFHOOKKEY_EVENT_NAME), &dwRead);
				if (bReadSucc) {
					if (memcmp(bTmpBuf, OFFHOOKKEY_EVENT_NAME, sizeof(OFFHOOKKEY_EVENT_NAME)) == 0) {
						dwOffHookPatchOffset = dwOffset;
						bCanPatch = TRUE;
						break;
					}
				}
			}
		}
		//

		if (bCanPatch && (dwFlag & HKH_HOOK_SLIDEOPEN)) {
			// SlideOpeň
			bCanPatch = FALSE;

			for (dwOffset = 0; dwOffset < pPatchProcessInfo->dwBaseSize - sizeof(SLIDEOPEN_EVENT_NAME); dwOffset++) {
				bReadSucc = ReadProcessMemory(hProcess, pPatchProcessInfo->pBaseAddr+dwOffset, bTmpBuf, sizeof(SLIDEOPEN_EVENT_NAME), &dwRead);
				if (bReadSucc) {
					if (memcmp(bTmpBuf, SLIDEOPEN_EVENT_NAME, sizeof(SLIDEOPEN_EVENT_NAME)) == 0) {
						dwSlideOpenPatchOffset = dwOffset;
						bCanPatch = TRUE;
						break;
					}
				}
			}
		}
		//

		if (bCanPatch && (dwFlag & HKH_HOOK_SLIDECLOSE)) {
			// SlideClosě
			bCanPatch = FALSE;

			for (dwOffset = 0; dwOffset < pPatchProcessInfo->dwBaseSize - sizeof(SLIDECLOSE_EVENT_NAME); dwOffset++) {
				bReadSucc = ReadProcessMemory(hProcess, pPatchProcessInfo->pBaseAddr+dwOffset, bTmpBuf, sizeof(SLIDECLOSE_EVENT_NAME), &dwRead);
				if (bReadSucc) {
					if (memcmp(bTmpBuf, SLIDECLOSE_EVENT_NAME, sizeof(SLIDECLOSE_EVENT_NAME)) == 0) {
						dwSlideClosePatchOffset = dwOffset;
						bCanPatch = TRUE;
						break;
					}
				}
			}
		}
		//

		if (bCanPatch) {
			if (dwFlag & HKH_HOOK_ONHOOK) {
				WriteProcessMemory(	hProcess,
									pPatchProcessInfo->pBaseAddr + dwOnHookPatchOffset,
									ONHOOKKEY_NEW_EVENT_NAME,
									sizeof(ONHOOKKEY_NEW_EVENT_NAME),
									&dwWritten);

				pPatchProcessInfo->dwOnHookOffset = dwOnHookPatchOffset;
			}
			if (dwFlag & HKH_HOOK_OFFHOOK) {
				WriteProcessMemory(	hProcess,
									pPatchProcessInfo->pBaseAddr + dwOffHookPatchOffset,
									OFFHOOKKEY_NEW_EVENT_NAME,
									sizeof(OFFHOOKKEY_NEW_EVENT_NAME),
									&dwWritten);

				pPatchProcessInfo->dwOffHookOffset = dwOffHookPatchOffset;
			}
			if (dwFlag & HKH_HOOK_SLIDEOPEN) {
				WriteProcessMemory(	hProcess,
									pPatchProcessInfo->pBaseAddr + dwSlideOpenPatchOffset,
									SLIDEOPEN_NEW_EVENT_NAME,
									sizeof(SLIDEOPEN_NEW_EVENT_NAME),
									&dwWritten);

				pPatchProcessInfo->dwSlideOpenOffset = dwSlideOpenPatchOffset;
			}
			if (dwFlag & HKH_HOOK_SLIDECLOSE) {
				WriteProcessMemory(	hProcess,
									pPatchProcessInfo->pBaseAddr + dwSlideClosePatchOffset,
									SLIDECLOSE_NEW_EVENT_NAME,
									sizeof(SLIDECLOSE_NEW_EVENT_NAME),
									&dwWritten);

				pPatchProcessInfo->dwSlideCloseOffset = dwSlideClosePatchOffset;
			}

			bRet = TRUE;
		}

		
		CloseHandle(hProcess);
		hProcess = NULL;
	}

	return bRet;
}

static
BOOL
doRestore(
	DWORD				dwFlag,
	HKH_PATCHPROCESSINFO*	pPatchProcessInfo
)
{
	BOOL	bRet = FALSE;
	HANDLE	hProcess = INVALID_HANDLE_VALUE;
	DWORD	dwWritten;

	if (pPatchProcessInfo == NULL) {
		return FALSE;
	}

	hProcess = OpenProcess(PROCESS_ALL_ACCESS, FALSE, pPatchProcessInfo->dwProcessId);
	if (hProcess != INVALID_HANDLE_VALUE) {

		if (dwFlag & HKH_HOOK_ONHOOK) {
			// OnHook̏C
			WriteProcessMemory(	hProcess,
								pPatchProcessInfo->pBaseAddr + pPatchProcessInfo->dwOnHookOffset,
								ONHOOKKEY_EVENT_NAME,
								sizeof(ONHOOKKEY_EVENT_NAME),
								&dwWritten);
			//
		}

		if (dwFlag & HKH_HOOK_OFFHOOK) {

			// OffHook̏C
			WriteProcessMemory(	hProcess,
								pPatchProcessInfo->pBaseAddr + pPatchProcessInfo->dwOffHookOffset,
								OFFHOOKKEY_EVENT_NAME,
								sizeof(OFFHOOKKEY_EVENT_NAME),
								&dwWritten);
			//
		}

		if (dwFlag & HKH_HOOK_SLIDEOPEN) {
			// SlideOpen̏C
			WriteProcessMemory(	hProcess,
								pPatchProcessInfo->pBaseAddr + pPatchProcessInfo->dwSlideOpenOffset,
								SLIDEOPEN_EVENT_NAME,
								sizeof(SLIDEOPEN_EVENT_NAME),
								&dwWritten);
			//
		}

		if (dwFlag & HKH_HOOK_SLIDECLOSE) {
			// SlideClosȅC
			WriteProcessMemory(	hProcess,
								pPatchProcessInfo->pBaseAddr + pPatchProcessInfo->dwSlideCloseOffset,
								SLIDECLOSE_EVENT_NAME,
								sizeof(SLIDECLOSE_EVENT_NAME),
								&dwWritten);
			//
		}

		CloseHandle(hProcess);
		hProcess = INVALID_HANDLE_VALUE;
		bRet = TRUE;
	}

	return bRet;
}


static
BOOL
NotifyOriginalEvent(
	LPTSTR	pEventName
)
{
	BOOL	bRet;
	HANDLE	hEvent;

	bRet = FALSE;

	hEvent = CreateEvent(NULL, FALSE, FALSE, pEventName);
	if (hEvent != NULL) {

		SetEvent(hEvent);
		CloseHandle(hEvent);
		hEvent = NULL;

		bRet = TRUE;
	}
	
	return bRet;
}

static
DWORD
WINAPI
HookKeyWatchThread(void* pParam)
{
	CHookKeyHook*	pHKH			= NULL;
	DWORD			dwObject		= 0;
	DWORD			dwNumEvent		= 0;
	BOOL			bStopRequest	= FALSE;
	DWORD			dwFlag			= 0;
	HKH_HOOKPROC	pfnHookProc		= NULL;
	void*			pUserData		= NULL;
	HANDLE			ahEvents[5];
	DWORD			adwEventIDs[5];

	if (pParam == NULL) {
		return 0;
	}

	pHKH = (CHookKeyHook*)pParam;
	dwFlag = pHKH->m_dwFlag;
	pfnHookProc = pHKH->m_pfnHookProc;
	pUserData	= pHKH->m_pUserData;

	if (pfnHookProc != NULL) {
		dwNumEvent = 0;
		ahEvents[dwNumEvent] = pHKH->m_hStopEvent;
		adwEventIDs[0]		 = 0;
		dwNumEvent++;

		if (dwFlag & HKH_HOOK_ONHOOK) {
			ahEvents[dwNumEvent]	= pHKH->m_hNewOnHookEvent;
			adwEventIDs[dwNumEvent]	= HKH_HOOK_ONHOOK;
			dwNumEvent++;
		}
		if (dwFlag & HKH_HOOK_OFFHOOK) {
			ahEvents[dwNumEvent] = pHKH->m_hNewOffHookEvent;
			adwEventIDs[dwNumEvent]	= HKH_HOOK_OFFHOOK;
			dwNumEvent++;
		}
		if (dwFlag & HKH_HOOK_SLIDEOPEN) {
			ahEvents[dwNumEvent] = pHKH->m_hNewSlideOpenEvent;
			adwEventIDs[dwNumEvent]	= HKH_HOOK_SLIDEOPEN;
			dwNumEvent++;
		}
		if (dwFlag & HKH_HOOK_SLIDECLOSE) {
			ahEvents[dwNumEvent] = pHKH->m_hNewSlideCloseEvent;
			adwEventIDs[dwNumEvent]	= HKH_HOOK_SLIDECLOSE;
			dwNumEvent++;
		}

		while (!pHKH->m_bStopRequest) {
			dwObject = WaitForMultipleObjects(dwNumEvent, ahEvents, FALSE, INFINITE);
			if (dwObject == WAIT_OBJECT_0) {
				// StopEvent
				;
			}
			else if ((WAIT_OBJECT_0 < dwObject) && (dwObject <  WAIT_OBJECT_0 + dwNumEvent)) {
				DWORD	dwAction;
				dwAction = adwEventIDs[dwObject - WAIT_OBJECT_0];
				
				if (dwAction == HKH_HOOK_SLIDEOPEN) {
					NotifyOriginalEvent(SLIDEOPEN_EVENT_NAME);
				}
				else if (dwAction == HKH_HOOK_SLIDECLOSE) {
					NotifyOriginalEvent(SLIDECLOSE_EVENT_NAME);
				}
				(*pfnHookProc)(dwAction, pUserData);
			}
			else {
				break;
			}
		}
	}

	return 0;
}

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////

CHookKeyHook::CHookKeyHook()
{
	m_bStopRequest	= FALSE;
	m_hStopEvent	= NULL;
	m_hThread		= NULL;

	m_hNewOnHookEvent		= NULL;
	m_hNewOffHookEvent		= NULL;
	m_hNewSlideOpenEvent	= NULL;
	m_hNewSlideCloseEvent	= NULL;

	m_pfnHookProc	= NULL;
	m_pUserData		= NULL;
	m_dwFlag		= 0;
	memset(&m_PatchProcessInfo, 0, sizeof(m_PatchProcessInfo));
}

CHookKeyHook::~CHookKeyHook()
{
	if (m_hThread != NULL) {
		StopHook();
	}
}

BOOL
CHookKeyHook::StartHook(
	DWORD			dwFlag,
	HKH_HOOKPROC	pfnHookProc,
	void*			pData
)
{
	BOOL	bRet;
	DWORD	dwThreadID	= 0; 

	bRet = FALSE;

	if (dwFlag == 0 || pfnHookProc == NULL || m_hThread != NULL) {
		return FALSE;
	}

	m_dwFlag		= dwFlag;
	m_pfnHookProc	= pfnHookProc;
	m_pUserData		= pData;

	m_hStopEvent = CreateEvent(NULL, FALSE, FALSE, NULL);
	if (m_hStopEvent == NULL) goto err_exit;

	if (dwFlag & HKH_HOOK_ONHOOK) {
		m_hNewOnHookEvent = CreateEvent(NULL, FALSE, FALSE, ONHOOKKEY_NEW_EVENT_NAME);
		if (m_hNewOnHookEvent == NULL) goto err_exit;
	}

	if (dwFlag & HKH_HOOK_OFFHOOK) {
		m_hNewOffHookEvent = CreateEvent(NULL, FALSE, FALSE, OFFHOOKKEY_NEW_EVENT_NAME);
		if (m_hNewOffHookEvent == NULL) goto err_exit;
	}

	if (dwFlag & HKH_HOOK_SLIDEOPEN) {
		m_hNewSlideOpenEvent = CreateEvent(NULL, FALSE, FALSE, SLIDEOPEN_NEW_EVENT_NAME);
		if (m_hNewSlideOpenEvent == NULL) goto err_exit;
	}

	if (dwFlag & HKH_HOOK_SLIDECLOSE) {
		m_hNewSlideCloseEvent	= CreateEvent(NULL, FALSE, FALSE, SLIDECLOSE_NEW_EVENT_NAME);
		if (m_hNewSlideCloseEvent == NULL) goto err_exit;
	}


	memset(&m_PatchProcessInfo, 0, sizeof(m_PatchProcessInfo));

	if (GetPatchProcessInfo(&m_PatchProcessInfo)) {
		if (doPatch(dwFlag, &m_PatchProcessInfo)) {
			m_hThread = (HANDLE)CreateThread(NULL, 0, HookKeyWatchThread, this, 0, &dwThreadID);
			if (m_hThread != NULL) {
				bRet = TRUE;
			}
			else {
				doRestore(dwFlag, &m_PatchProcessInfo);
			}
		}
	}

	if (bRet) {
		return TRUE;
	}


err_exit:
	memset(&m_PatchProcessInfo, 0, sizeof(m_PatchProcessInfo));

	if (m_hNewSlideCloseEvent != NULL) {
		CloseHandle(m_hNewSlideCloseEvent);
		m_hNewSlideCloseEvent = NULL;
	}
	if (m_hNewSlideOpenEvent != NULL) {
		CloseHandle(m_hNewSlideOpenEvent);
		m_hNewSlideOpenEvent = NULL;
	}
	if (m_hNewOffHookEvent != NULL) {
		CloseHandle(m_hNewOffHookEvent);
		m_hNewOffHookEvent = NULL;
	}
	if (m_hNewOnHookEvent != NULL) {
		CloseHandle(m_hNewOnHookEvent);
		m_hNewOnHookEvent = NULL;
	}
	if (m_hStopEvent != NULL) {
		CloseHandle(m_hStopEvent);
		m_hStopEvent = NULL;
	}
	m_pUserData		= NULL;
	m_pfnHookProc	= NULL;
	m_dwFlag		= 0;

	return FALSE;
}

BOOL
CHookKeyHook::StopHook(
)
{
	if (m_hThread == NULL) {
		return FALSE;
	}

	m_bStopRequest = TRUE;
	SetEvent(m_hStopEvent);

	WaitForSingleObject(m_hThread, INFINITE);
	CloseHandle(m_hThread);
	m_hThread = NULL;

	doRestore(m_dwFlag, &m_PatchProcessInfo);

	memset(&m_PatchProcessInfo, 0, sizeof(m_PatchProcessInfo));

	if (m_hNewSlideCloseEvent != NULL) {
		CloseHandle(m_hNewSlideCloseEvent);
		m_hNewSlideCloseEvent = NULL;
	}
	if (m_hNewSlideOpenEvent != NULL) {
		CloseHandle(m_hNewSlideOpenEvent);
		m_hNewSlideOpenEvent = NULL;
	}
	if (m_hNewOffHookEvent != NULL) {
		CloseHandle(m_hNewOffHookEvent);
		m_hNewOffHookEvent = NULL;
	}
	if (m_hNewOnHookEvent != NULL) {
		CloseHandle(m_hNewOnHookEvent);
		m_hNewOnHookEvent = NULL;
	}
	if (m_hStopEvent != NULL) {
		CloseHandle(m_hStopEvent);
		m_hStopEvent = NULL;
	}

	m_pUserData		= NULL;
	m_pfnHookProc	= NULL;
	m_dwFlag		= 0;

	return TRUE;
}

void
CHookKeyHook::OnHook()
{
	NotifyOriginalEvent(ONHOOKKEY_EVENT_NAME);
}

void
CHookKeyHook::OffHook()
{
	NotifyOriginalEvent(OFFHOOKKEY_EVENT_NAME);
}